/*
 *  SP`
 *
 *  $Id:$
 */
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"
#include "tsp.h"
#include "shoot.h"

#define almix(d,s,a)  {(d).r=((d).r * (255-(a)) + (s).r * (a))/256 ;\
                       (d).g=((d).g * (255-(a)) + (s).g * (a))/256 ;\
                       (d).b=((d).b * (255-(a)) + (s).b * (a))/256 ;}

int draw_sp( struct TSP_WINDOW *win )
{
  int i,x,y,m ;
  int width,height ;
  int alpha1, alpha2 ;
  struct TSP_PIX *tmpp ;
  struct TSP_PIX clr_pix={0,0,0,0} ;
  
  
  if( win==NULL ) return( TSP_INVALID_WINDOW_ERROR )  ;
  tmpp=gd->vram ;

  for( y=0 ; y<tsp_win->height ; y++ ){
    for( x=0 ; x<tsp_win->width ; x++ ){
      tmpp[x+y*tsp_win->real_width]=clr_pix ;
    }
  }
  
  for( i=tsp_pcg.sp_cur-1 ; i>=0 ; i-- ){
    width =tsp_pcg.chip[tsp_pcg.sp[i]->pat]->w ;
    height=tsp_pcg.chip[tsp_pcg.sp[i]->pat]->h ;
    m=0 ;
    for( y=0 ; y<height ; y++ ){
      for( x=0 ; x<width ; x++,m++ ){
	if( tsp_pcg.sp[i]->y+y<0 || tsp_pcg.sp[i]->y+y>=win->height ||
	    tsp_pcg.sp[i]->x+x<0 || tsp_pcg.sp[i]->x+x>=win->width ){
	  continue ;
	}
	alpha1=tsp_pcg.chip[tsp_pcg.sp[i]->pat]->map[m].a ;
	alpha2=tsp_pcg.sp[i]->a ;
	if( alpha1==0 || alpha2==0 ) continue ;
	if( alpha1==255 && alpha2==255 ){
	  tmpp[ (tsp_pcg.sp[i]->y+y) * win->real_width + (tsp_pcg.sp[i]->x+x) ]
	    = tsp_pcg.chip[tsp_pcg.sp[i]->pat]->map[m] ;
	}else{
	  alpha1=alpha1*alpha2/256 ;
	  almix(tmpp[ (tsp_pcg.sp[i]->y+y) * win->real_width + (tsp_pcg.sp[i]->x+x) ],
		tsp_pcg.chip[tsp_pcg.sp[i]->pat]->map[m] ,alpha1) ;
	}
      }
    }
  }
  tsp_pcg.sp_cur = 0 ;
  
  GdevSync() ; /* wait for complete draw graphic */
  
  return( 0 ) ;
}
