/*****************************************************************
   Initialize System
   $Id:$
 *****************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"
#include "tsp.h"
#include "shoot.h"

int init()
{
  /*** allocate SP ***/
  sp=malloc( sizeof(struct TSP_SP) * MAX_SP ) ;
  if( sp==NULL ) return(FAILD) ;
  
  /*** init TSP system ***/
  tsp_win=init_window() ;
  if( tsp_win==NULL        ) return(FAILD) ;
  if( init_pcg(MAX_PCG)!=0 ) return(FAILD) ;
  if( init_sp(MAX_SP) !=0  ) return(FAILD) ;

  return( NORMAL_EXIT ) ;

}
