/*****************************************************************
   V[eBOQ[f wb_t@C
   $Id:$
 *****************************************************************/
#define MAX_SP    8192
#define MAX_PCG   8192

struct TSP_WINDOW *tsp_win   ;
struct TSP_SP     *sp        ;
int    spcount ;

#define NORMAL_EXIT    0
#define FAILD         -1


int init() ;
int read_pat() ;
int game() ;

#define JIKI_NUM     1
#define TEKI_NUM    32
#define SHOT_NUM     4
#define TAMA_NUM  4096
#define BOMB_NUM  4096
#define STAR_NUM    32

struct CHAR_STAT{
  int stat  ;
  int x     ;
  int y     ;
  int dx    ;
  int dy    ;
  int left  ;
  int life  ;
  int time  ;
  int score ;
  int pat   ;
  int flag1 ;
  int flag2 ;
  int flag3 ;
  int (*bomfunc)();
  struct CHAR_STAT *next ;
  struct CHAR_STAT *prev ;
} ;

struct CHAR_STAT JIKI[JIKI_NUM] ;
struct CHAR_STAT TEKI[TEKI_NUM] ;
struct CHAR_STAT SHOT[SHOT_NUM*3] ;
struct CHAR_STAT TAMA[TAMA_NUM] ;
struct CHAR_STAT BOMB[BOMB_NUM] ;
struct CHAR_STAT STAR[TEKI_NUM] ;
struct CHAR_STAT *TAMA_ACT_LIST ;
struct CHAR_STAT *TAMA_SLP_LIST ;
struct CHAR_STAT *BOMB_ACT_LIST ;
struct CHAR_STAT *BOMB_SLP_LIST ;
int tama_count ;

#define MULGETA(a) ((a)*256)
#define DIVGETA(a) ((a)/256)

#define SLEEP    0
#define ACTIVE   1
#define GHOST    2
#define COMPLETE 3

#define TBL_SIZE  512
int sin_tbl[TBL_SIZE] ;
int cos_tbl[TBL_SIZE] ;
int atn_tbl[TBL_SIZE] ;

int game_timer ;

int jiki_pat ;
int teki_pat ;
int tama_pat ;
int bomb_pat ;
int shotl_pat ;
int shotc_pat ;
int shotr_pat ;
int demo_pat ;
int ascii_pat ;
int boss_pat ;

#define AdActTAMAlist(actp,slpp) {\
    struct CHAR_STAT *tmp ;\
    tmp=slpp ;\
    slpp=slpp->next ; \
    actp->next->prev=tmp ;\
    tmp->next=actp->next ;\
    actp->next=tmp ;\
    tmp->prev=actp ;\
  }

#define RmActTAMAlist(actp,slpp) {\
    struct CHAR_STAT *nextp ;\
    struct CHAR_STAT *prevp ;\
    nextp=actp->next ; \
    prevp=actp->prev ; \
    if( nextp!=NULL ) nextp->prev=prevp ;\
    if( prevp!=NULL ) prevp->next=nextp ;\
    actp->prev=NULL ;\
    actp->next=slpp ;\
    slpp=actp ;\
    actp=nextp ;\
  }
